defmodule NullaWeb.ActivityPub.ActorController do
  use NullaWeb, :controller
  alias NullaWeb.ActivityPub.ActorJSON
  alias Nulla.Actors
  alias Nulla.Actors.Actor

  def show(conn, %{"username" => username}) do
    domain = NullaWeb.Endpoint.host()

    case Actors.get_actor_by(acct: "#{username}@#{domain}") do
      nil ->
        conn
        |> put_status(:not_found)
        |> json(%{error: "Not Found"})

      %Actor{} = actor ->
        conn
        |> put_resp_content_type("application/activity+json")
        |> send_resp(200, Jason.encode!(ActorJSON.show(actor)))
    end
  end
end
